module API
  class API::Node < ActiveResource::Base
    def self.top_directory_nodes
      self.find(:all, :from => :to_directory_nodes)
    end

    def parent
      @@parent ||= Hash.new
      if @@parent.has_key?(path)
        @@parent[path]
      else
        begin
          parent = self.class.find(:one, :from => "/nodes/#{self.id}/parent.xml")
        rescue ActiveResource::ResourceNotFound
          parent = nil
        end
        @@parent[path] = parent
      end
    end

    def children
      @@children ||= Hash.new
      @@children[path] ||= self.class.find(:all, :from => "/nodes/#{self.id}/children.xml")
    end

    def keyword_attributes
      @@keyword_attributes ||= Hash.new
      @@keyword_attributes[path] ||= self.class.find(:all, :from => "/nodes/#{self.id}/keyword_attributes.xml")
    end

    %w(directory variable image knowledge).each{|type|
      eval <<"EOF"
    def #{type}_nodes(user=nil)
      @@#{type}_nodes ||= Hash.new
      if tn = @@#{type}_nodes[path]
        return tn
      else
        @@#{type}_nodes[path] = (ary = Array.new)
        self.children.each{|node|
          if node.node_type == "#{type}"
            ary.push node
          end
        }
        return ary
      end
    end
    def count_#{type}_nodes(user=nil)
      #{type}_nodes.length
    end
    def #{type}?
      node_type == "#{type}"
    end
EOF
  }

    def has_directory_nodes?(user=nil)
      self.num_dirs.length > 0
    end

    def entity
      self
    end

    def full_path
      self.class.site.to_s + "@" + path
    end

    def stdname(name)
      self.keyword_attributes.each{|ka|
        if KeywordAttribute::StdName[name].include?(ka.name)
          return ka
        end
      }
      return nil
    end

    def references(*arg)
      []
    end
    def referenced_by(*arg)
      []
    end
    def knowledges(*arg)
      []
    end
    def plain_file
      false
    end

  end
end

Node_Remote = Array.new
if GFDNAVI_OTHER_GFDNAVI_SERVERS
  module API
  end
  GFDNAVI_OTHER_GFDNAVI_SERVERS.each_with_index{|gs,id|
    mod_name = "API::Server#{id}"
    eval <<"EOF"
      module #{mod_name}
        class Node < API::Node
          self.site = "#{gs}"
        end
      end
      Node_Remote.push #{mod_name}::Node
EOF
  }
end
