package {

  import mx.controls.treeClasses.DefaultDataDescriptor;
  import mx.collections.ICollectionView;
  import mx.collections.ArrayCollection;
  import mx.controls.Alert;
  import mx.rpc.AsyncResponder;
  import mx.rpc.AsyncToken;
  import mx.rpc.http.mxml.HTTPService;
  import mx.controls.Tree;
  import flash.events.Event;
  import mx.events.CollectionEvent;
  import mx.events.PropertyChangeEvent;

  public class TreeNode {

      public function TreeNode(host:String):void {
	  super();
          this.host = host;
      }

      [Embed(source='../images/tree/folder.png')]
      [Bindable]
      public var closedFolderIcon:Class;

      [Embed(source='../images/tree/binary.png')]
      [Bindable]
      public var binaryIcon:Class;

      [Embed(source='../images/tree/image2.png')]
      [Bindable]
      public var imageIcon:Class;

      [Embed(source='../images/tree/knowledge_icon.png')]
      [Bindable]
      public var knowledgeIcon:Class;

      [Embed(source='../images/tree/anal_viz.png')]
      [Bindable]
      public var analysisIcon:Class;

      [Embed(source='../images/tree/show.png')]
      [Bindable]
      public var showIcon:Class;


      public static var hs:HTTPService;
      public static var tree:Tree;
      public static var changeHandler:Function;


      public var host:String;
      public var has_variable:Boolean;
      public var has_image:Boolean;

      public var has_children:Boolean;
      private var childrenUri:String;

      private var _chld:ArrayCollection;
      private var _dirs:ArrayCollection;
      private var _vars:ArrayCollection;
      private var _imgs:ArrayCollection;

      private var _kas:ArrayCollection;

      public var name:String;
      public var path:String;
      public var size:int;
      public var node_type:String;
      public var mtime:String;
      public var title:String;
      public var description:String;
      public var parent:Object;
      public var numDirs:int;
      public var imgSrc:String;

      public var dlUri:String;


      public function toString():String { return "[Object TreeNode]"};

      public function get directories():ArrayCollection {
	  getChildren();
	  return _dirs;
      }
      public function set directories(dirs:ArrayCollection):void {
	  _dirs = dirs;
      }
      public function get variables():ArrayCollection {
	  getChildren();
	  return _vars;
      }
      public function set variables(vars:ArrayCollection):void {
	  _vars = vars;
      }
      public function get images():ArrayCollection {
	  getChildren();
	  return _imgs;
      }
      public function set images(imgs:ArrayCollection):void {
	  _imgs = imgs;
      }
      public function get children():ArrayCollection {
	  getChildren();
	  return _chld;
      }
      public function set children(chld:ArrayCollection):void {
	  _chld = chld;
      }

      public function get keywordAttributes():ArrayCollection {
	  var ary:ArrayCollection;
          if (!_kas) {
	      _kas = (ary = new ArrayCollection());
	      hs.url = host + "/data" + this.path + "/keyword_attributes.xml";
	      hs.method = "GET";
	      var call:AsyncToken = hs.send();

	      call.addResponder(new AsyncResponder(
                function (result:Object, token:Object = null):void {
                   trace(result.toString(), "succeded to get Node Keyword Attributes");
                   var obj:Object;
	           var kas:Object;
	           if ( result.result.hasOwnProperty("keyword-attributes") ) {
                     kas = result.result["keyword-attributes"];
		     if (kas) {
			 kas = kas["keyword-attribute"];
			 if (!kas.length) kas = new Array(kas);
			 var ka:Object;
			 for (var i:int=0; i < kas.length; i++) {
			     ka = kas[i];
			     obj = new Object();
			     obj.name = ka.name;
			     obj.value = ka.value;
			     obj.lang = ka.lang;
			     ary.addItem(obj);
			 }
		     }
		   }
		},
		function (error:Object, token:Object = null):void {
                    trace(error.toString());
                    Alert.show("failed to get Node Keyword Attributes","Error");
		},
		call
            ));
	  }
	  return _kas;
      }

      private function getChildren():void {
	  if (!this.has_children) {
	      this.has_children = true;
	      getNodes(this.childrenUri, this);
	  }
      }

      public function getNodeTypeIcon():Class {
	  if (this.node_type == "directory") {
	      return closedFolderIcon;
	  } else if (this.node_type == "variable") {
	      return binaryIcon;
	  } else if (this.node_type == "image") {
	      return imageIcon;
	  } else if (this.node_type == "knowledge") {
	      return knowledgeIcon;
	  }
	  return closedFolderIcon;
      }

      public function getNodeActionIcon():Class {
	  if (this.node_type == "directory") {
	    if (this.variables.length > 0 )
	          return analysisIcon;
	  } else if (this.node_type == "variable") {
	      return analysisIcon;
	  } else if (this.node_type == "image") {
	      return showIcon;
	  }
          return null;
      }

      public static function getNodes(uri:String, parent:Object):ArrayCollection {
	  var dis:ArrayCollection;
	  var vas:ArrayCollection;
	  var ims:ArrayCollection;
	  var chd:ArrayCollection;
	  var host:String = parent.host;

	  dis = new ArrayCollection();
	  if (parent is TreeNode) {
	      chd = new ArrayCollection();
              vas = new ArrayCollection();
              ims = new ArrayCollection();
	      parent.directories = dis;
	      parent.variables = vas;
	      parent.images = ims;
	      parent.children = chd;
	  }

	  hs.url = uri + "?num_dirs=true";
	  hs.method = "GET";
	  var call:AsyncToken = hs.send();

	  call.addResponder(new AsyncResponder(
              function (result:Object, token:Object = null):void {
                 trace(result.toString(), "succeded to get Nodes");
                 var obj:TreeNode;
		 var nodes:Object = result.result.nodes.node;
		 if (!nodes.length)  nodes = new Array(nodes);
		 var node:Object;
		 for (var i:int=0; i < nodes.length; i++) {
		     node = nodes[i];
		     obj = new TreeNode(host);
		     obj.name = node.name;
		     obj.numDirs = node.num_dirs;
		     obj.path = node.path;
		     obj.size = node.size;
		     obj.node_type = node.node_type;
		     obj.mtime = node.mtime;
                     obj.childrenUri = node.children.uri;
		     if (node.title is String) if (node.title!="NULL") obj.title = node.title;
		     if (node.description is String ) if (node.description!="NULL") obj.description = node.description;
                     obj.imgSrc = node.img_src;
                     obj.dlUri = node.dl_uri;
		     if (parent is TreeNode) obj.parent = parent;
		     if (node.node_type == "directory") {
		       dis.addItem(obj);
      		     } else if (node.node_type == "variable") {
                       if (vas) vas.addItem(obj);
		     } else if (node.node_type == "image") {
                       if (ims) ims.addItem(obj);
                     }
		     if (chd) chd.addItem(obj);
		 }

		 changeHandler(parent);

	      },
	      function (error:Object, token:Object = null):void {
                  Alert.show("faild to list Nodes","error");
                  trace(error.toString());
		  parent.has_children = false;
	      },
	      call
          ));
	  return dis;
      }


  }
}

